using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;

namespace Payment
{
	/// <summary>
	/// Data Layer 
	/// </summary>
	public class DataRetriever
	{
		private const string connectionStringKeyName = "ConnectionString";
		private readonly string connectionString;

		public DataRetriever()
		{
			connectionString = ConfigurationSettings.AppSettings[connectionStringKeyName];
		}

		public StatusCodesDataset StatusCodes()
		{
			const string sql = "SELECT * FROM StatusCodeMapping";

			try
			{
				using(SqlConnection connection = new SqlConnection(connectionString))
				{
					connection.Open();
				
					using( SqlCommand sqlCommand = new SqlCommand(sql,connection) )
					{
						sqlCommand.CommandType = CommandType.Text;

						// Fill a dataset.
						using( SqlDataAdapter adapter = new SqlDataAdapter(sqlCommand) )
						{
							StatusCodesDataset dataSet = new StatusCodesDataset();
			
							adapter.Fill(dataSet.StatusCodeMapping);
							
							return dataSet;
						}
					}	
				}
			}
			catch(Exception ex)
			{
				throw ex;
			}
		}
	}
}
