using System;
using System.Configuration;

namespace Payment
{
	/// <summary>
	/// StatusCodesCache   Դϴ.
	/// </summary>
	public sealed class StatusCodesCache
	{
		private const string statusCodesReadingMinutesKeyName = "StatusCodesReadingMinutes";
		private StatusCodesDataset statusCodes = null;
		private TimeSpan statusCodesReadingMinutes;
		private DateTime previousStatusCodesReadTime;


		StatusCodesCache()
		{
			int minutes = int.Parse( ConfigurationSettings.AppSettings[statusCodesReadingMinutesKeyName] );
			statusCodesReadingMinutes = new TimeSpan(0,minutes,0);
			previousStatusCodesReadTime = DateTime.Now;
		}

		public StatusCodesDataset StatusCodes
		{
			get
			{
				if(statusCodes == null 
					|| DateTime.Now - previousStatusCodesReadTime > statusCodesReadingMinutes)
				{
					previousStatusCodesReadTime = DateTime.Now;

					DataRetriever retriever = new DataRetriever();
					statusCodes = retriever.StatusCodes();

					Console.WriteLine("Refresh!");
				}

				return statusCodes;
			}
		}

		public static StatusCodesCache Instance
		{
			get
			{
				return Nested.instance;
			}
		}
    
		class Nested
		{
			static Nested()
			{
			}

			internal static readonly StatusCodesCache instance = new StatusCodesCache();
		}
	}
}
